org.glassfish.jersey.spi

## Interface ExecutorServiceProvider

All Known Subinterfaces:
  ScheduledExecutorServiceProvider

All Known Implementing Classes:
  ScheduledThreadPoolExecutorProvider, ThreadPoolExecutorProvider

    @Contract
    public interface ExecutorServiceProvider

An extension contract for providing pluggable executor service providers to be used by Jersey client or server runtime whenever a specific executor service is needed to execute a Jersey runtime processing task.

This mechanism allows Jersey to run in environments that have specific thread management and provisioning requirements, such as application servers, cloud environments etc. Dedicated Jersey extension modules or applications running in such environment may provide a custom implementation of the `ExecutorServiceProvider` interface to customize the default Jersey runtime thread management & provisioning strategy in order to comply with the threading requirements, models and policies specific to each particular environment.

When Jersey runtime no longer requires the use of a provided executor service instance, it invokes the provider's `dispose(java.util.concurrent.ExecutorService)` method to signal the provider that the executor service instance can be disposed of. In this method, provider is free to implement the proper shut-down logic for the disposed executor service instance and perform other necessary cleanup. Yet, some providers may wish to implement a shared executor service strategy. In such case, it may not be desirable to shut down the released executor service in the `dispose(java.util.concurrent.ExecutorService)` method. Instead, to perform the eventual shut-down procedure, the provider may either rely on an explicit invocation of it's specific clean-up method. Since all Jersey providers operate in a container environment, a good clean-up strategy for a shared executor service provider implementation is to expose a `@PreDestroy`-annotated method that will be invoked for all instances managed by the container, before the container shuts down.

IMPORTANT: Please note that any pre-destroy methods may not be invoked for instances created outside of the container and later registered within the container. Pre-destroy methods are only guaranteed to be invoked for those instances that are created and managed by the container.

Jersey runtime expects that a concrete executor service provider implementation class is annotated with a `qualifier` annotation. This qualifier is then used to createAndInitialize a qualified injection point for injecting the executor service instance provided by the annotated provider. `Named` providers are also supported. For example:

     @Named("my-executor")
     public MyExecutorProvider implements ExecutorServiceProvider {
         ...
     }

     ...

     // Injecting ExecutorService provided by the MyExecutorProvider
     @Inject @Named("my-executor") ExecutorService myExecutor;

Since:
  2.18
Author:
  Marek Potociar
See Also:
  `ScheduledExecutorServiceProvider`, `ThreadPoolExecutorProvider`

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `dispose(ExecutorService executorService)` Invoked when Jersey runtime no longer requires use of the provided executor service.
`ExecutorService` `getExecutorService()` Get an executor service to be used by Jersey client or server runtime to execute specific tasks.

### Method Detail

#### getExecutorService

    ExecutorService getExecutorService()

Get an executor service to be used by Jersey client or server runtime to execute specific tasks.

This method is usually invoked just once at either Jersey client or server application runtime initialization, it may however be invoked multiple times. Once the instance of the provided executor service is not needed anymore by Jersey application runtime, it will be `disposed`. This typically happens in one of the following situations:

- Jersey client instance is closed (client runtime is shut down).
- Jersey container running a server-side Jersey application is shut down.
- Jersey server-side application is un-deployed.

Returns:
  an executor service. Must not return `null`.

#### dispose

    void dispose(ExecutorService executorService)

Invoked when Jersey runtime no longer requires use of the provided executor service.

Parameters:
  `executorService` - executor service to be disposed.